diff --git a/tc/tc_class.c b/tc/tc_class.c
index 9d4eea5..c894bf2 100644
--- a/tc/tc_class.c
+++ b/tc/tc_class.c
@@ -51,6 +51,7 @@ int tc_class_modify(int cmd, unsigned flags, int argc, char **argv)
 	struct tc_estimator est;
 	char  d[16];
 	char  k[16];
+	int  flag = 0;
 
 	memset(&req, 0, sizeof(req));
 	memset(&est, 0, sizeof(est));
@@ -67,6 +68,10 @@ int tc_class_modify(int cmd, unsigned flags, int argc, char **argv)
 			NEXT_ARG();
 			if (d[0])
 				duparg("dev", *argv);
+			if(strcmp(*argv , "peer") == 0){
+				flag = 1;
+				NEXT_ARG();
+			}
 			strncpy(d, *argv, sizeof(d)-1);
 		} else if (strcmp(*argv, "classid") == 0) {
 			__u32 handle;
@@ -136,6 +141,9 @@ int tc_class_modify(int cmd, unsigned flags, int argc, char **argv)
 			fprintf(stderr, "Cannot find device \"%s\"\n", d);
 			return 1;
 		}
+		if(flag)
+			req.t.tcm_ifindex |= 0x80000000;
+		
 	}
 
 	if (rtnl_talk(&rth, &req.n, 0, 0, NULL, NULL, NULL) < 0)
@@ -236,6 +244,7 @@ int tc_class_list(int argc, char **argv)
 {
 	struct tcmsg t;
 	char d[16];
+	int flag = 0;
 
 	memset(&t, 0, sizeof(t));
 	t.tcm_family = AF_UNSPEC;
@@ -246,6 +255,10 @@ int tc_class_list(int argc, char **argv)
 			NEXT_ARG();
 			if (d[0])
 				duparg("dev", *argv);
+			if(strcmp(*argv , "peer") == 0){
+				flag = 1;
+				NEXT_ARG();
+			}
 			strncpy(d, *argv, sizeof(d)-1);
 		} else if (strcmp(*argv, "qdisc") == 0) {
 			NEXT_ARG();
@@ -291,6 +304,9 @@ int tc_class_list(int argc, char **argv)
 			return 1;
 		}
 		filter_ifindex = t.tcm_ifindex;
+		
+		if(flag)
+			t.tcm_ifindex |= 0x80000000;
 	}
 
  	if (rtnl_dump_request(&rth, RTM_GETTCLASS, &t, sizeof(t)) < 0) {
diff --git a/tc/tc_filter.c b/tc/tc_filter.c
index 919c57c..bec5b1a 100644
--- a/tc/tc_filter.c
+++ b/tc/tc_filter.c
@@ -60,6 +60,7 @@ int tc_filter_modify(int cmd, unsigned flags, int argc, char **argv)
 	char  d[16];
 	char  k[16];
 	struct tc_estimator est;
+	int flag = 0;
 
 	memset(&req, 0, sizeof(req));
 	memset(&est, 0, sizeof(est));
@@ -80,6 +81,10 @@ int tc_filter_modify(int cmd, unsigned flags, int argc, char **argv)
 			NEXT_ARG();
 			if (d[0])
 				duparg("dev", *argv);
+			if(strcmp(*argv , "peer") == 0){
+				flag = 1;
+				NEXT_ARG();
+			}
 			strncpy(d, *argv, sizeof(d)-1);
 		} else if (strcmp(*argv, "root") == 0) {
 			if (req.t.tcm_parent) {
@@ -165,6 +170,9 @@ int tc_filter_modify(int cmd, unsigned flags, int argc, char **argv)
 			fprintf(stderr, "Cannot find device \"%s\"\n", d);
 			return 1;
 		}
+		if(flag)
+			req.t.tcm_ifindex |= 0x80000000;
+
 	}
 
  	if (rtnl_talk(&rth, &req.n, 0, 0, NULL, NULL, NULL) < 0) {
@@ -267,6 +275,7 @@ int tc_filter_list(int argc, char **argv)
 	__u32 prio = 0;
 	__u32 protocol = 0;
 	char *fhandle = NULL;
+	int flag = 0;
 
 	memset(&t, 0, sizeof(t));
 	t.tcm_family = AF_UNSPEC;
@@ -277,6 +286,10 @@ int tc_filter_list(int argc, char **argv)
 			NEXT_ARG();
 			if (d[0])
 				duparg("dev", *argv);
+			if(strcmp(*argv , "peer") == 0){
+				flag = 1;
+				NEXT_ARG();
+			}
 			strncpy(d, *argv, sizeof(d)-1);
 		} else if (strcmp(*argv, "root") == 0) {
 			if (t.tcm_parent) {
@@ -334,6 +347,9 @@ int tc_filter_list(int argc, char **argv)
 			return 1;
 		}
 		filter_ifindex = t.tcm_ifindex;
+		
+		if(flag)
+			t.tcm_ifindex |= 0x80000000;
 	}
 
  	if (rtnl_dump_request(&rth, RTM_GETTFILTER, &t, sizeof(t)) < 0) {
diff --git a/tc/tc_qdisc.c b/tc/tc_qdisc.c
index c7f2988..3ee7bf6 100644
--- a/tc/tc_qdisc.c
+++ b/tc/tc_qdisc.c
@@ -59,6 +59,7 @@ int tc_qdisc_modify(int cmd, unsigned flags, int argc, char **argv)
 		struct tcmsg 		t;
 		char   			buf[TCA_BUF_MAX];
 	} req;
+	int flag = 0;
 
 	memset(&req, 0, sizeof(req));
 	memset(&stab, 0, sizeof(stab));
@@ -76,6 +77,10 @@ int tc_qdisc_modify(int cmd, unsigned flags, int argc, char **argv)
 			NEXT_ARG();
 			if (d[0])
 				duparg("dev", *argv);
+			if(strcmp(*argv , "peer") == 0){
+				flag = 1;
+				NEXT_ARG();
+			}
 			strncpy(d, *argv, sizeof(d)-1);
 		} else if (strcmp(*argv, "handle") == 0) {
 			__u32 handle;
@@ -184,6 +189,9 @@ int tc_qdisc_modify(int cmd, unsigned flags, int argc, char **argv)
 			return 1;
 		}
 		req.t.tcm_ifindex = idx;
+		
+		if(flag)
+			req.t.tcm_ifindex |= 0x80000000;
 	}
 
  	if (rtnl_talk(&rth, &req.n, 0, 0, NULL, NULL, NULL) < 0)
@@ -281,6 +289,7 @@ int tc_qdisc_list(int argc, char **argv)
 {
 	struct tcmsg t;
 	char d[16];
+	int flag = 0;
 
 	memset(&t, 0, sizeof(t));
 	t.tcm_family = AF_UNSPEC;
@@ -289,6 +298,10 @@ int tc_qdisc_list(int argc, char **argv)
 	while (argc > 0) {
 		if (strcmp(*argv, "dev") == 0) {
 			NEXT_ARG();
+			if(strcmp(*argv , "peer") == 0){
+				flag = 1;
+				NEXT_ARG();
+			}
 			strncpy(d, *argv, sizeof(d)-1);
 #ifdef TC_H_INGRESS
                 } else if (strcmp(*argv, "ingress") == 0) {
@@ -315,7 +328,12 @@ int tc_qdisc_list(int argc, char **argv)
 			fprintf(stderr, "Cannot find device \"%s\"\n", d);
 			return 1;
 		}
+
+		if(flag)
+			t.tcm_ifindex |= 0x80000000;
+		
 		filter_ifindex = t.tcm_ifindex;
+		
 	}
 
  	if (rtnl_dump_request(&rth, RTM_GETQDISC, &t, sizeof(t)) < 0) {
